uses Crt;

const
  FieldWidth = 80;
  FieldHeight = 24;
  Speed = 1;
  MoveKeys : array [0..3, 0..1] of string [2] =
    ((#0#75, #0#77), ('Z', 'X'), (',', '.'), ('2', '3'));

type
  mvdir = (North, East, South, West);
  Beam = record
    headX : byte;
    headY : byte;
    direction : mvdir;
    alive : boolean
  end;

const BeamStart : array [0..0] of Beam =
((headX:20; headY:12; direction:East; alive:True));

var
  winner : byte;
  endgame : boolean;

procedure VideoStop;
begin
end;

procedure VideoShow;
begin
end;

procedure DrawBeamHead (player, X, Y : byte; dir : mvdir);
begin
  GotoXY (X, Y+1);
  if player<> 4 then Write ('');
end;

procedure DrawBeamBody (player, X, Y : byte; dir1, dir2 : mvdir);
begin
end;

procedure Fade (player : byte; var FinishedBeams : byte);
begin
  if player = 255 then FinishedBeams := 0
   else FinishedBeams := 1;
end;

procedure DieMusic;
begin
end;

procedure MoveMusic;
begin
end;

procedure WaitTime;
var Timer : longint absolute $40:$6C;
    OldTimer : longint;
begin
  OldTimer := Timer;
  while Timer = OldTimer do;
end;

function Session (NoOfPlayers, gameNo : byte; Border : boolean;
		  var endgame : boolean) : byte; {Winner}

const MvBufSize = 16;
var Board : array [0..FieldWidth-1, 0..FieldHeight-1] of boolean;
    Beams : array [0..3] of Beam;
    MoveBuf : array [0..3, 0..MvBufSize-1] of mvdir;
    BufReadPos, BufWritePos : array [0..MvBufSize-1] of byte;
    NoOfMoves : Word;
    NewDir : mvdir;
    AliveBeams, FinishedBeams, Tick : Byte;
    i : Byte;

  procedure ReadMvBuf;
  var KeyBuf : string [2];
      i : byte;
  begin
    while KeyPressed do
    begin
      KeyBuf := ReadKey;
      if KeyBuf = #0 then KeyBuf := #0 + ReadKey
	else if (KeyBuf >= 'a') and (KeyBuf <= 'z') then
	       KeyBuf := Chr (Ord (KeyBuf [1]) - 32);
      i := 0;
      while (i <= 7) and (KeyBuf <> MoveKeys [i shr 1, i and 1]) do Inc (i);
      if i <= 7 then
      begin
	if i and 1 = 0 then
	  MoveBuf [i shr 1, BufWritePos [i shr 1]] :=
	  MvDir ((Byte (MoveBuf [i shr 1, (BufWritePos [i shr 1]
	  + MvBufSize - 1) mod MvBufSize]) + 3) mod 4)
	else
	  MoveBuf [i shr 1, BufWritePos [i shr 1]] :=
	  MvDir ((Byte (MoveBuf [i shr 1, (BufWritePos [i shr 1]
	  + MvBufSize - 1) mod MvBufSize]) + 1) mod 4);
	BufWritePos [i shr 1] := (BufWritePos [i shr 1] + 1) mod MvBufSize;
      end
      else
	if KeyBuf = #27 then endgame := True;
    end;
  end;

  procedure ProcessMvBuf (Player : byte; var NewDir : mvdir);
  begin
    if BufReadPos [Player] <> BufWritePos [Player] then
    begin
      NewDir := MoveBuf [Player, BufReadPos [Player]];
      BufReadPos [Player] := (BufReadPos [Player] + 1) mod MvBufSize;
    end;
  end;

  procedure InitField;
  var i : byte;
  begin
    AliveBeams := NoOfPlayers;
    FillChar (Board, SizeOf (Board), 0);
    Fade (255, FinishedBeams);
    NoOfMoves := 0;
    endgame := False;
    FillChar (BufReadPos [0], SizeOf (BufReadPos), 0);
    FillChar (BufWritePos [0], SizeOf (BufWritePos), 0);
    Beams [0] := BeamStart [0];
    for i := 0 to NoOfPlayers - 1 do
      MoveBuf [i, MvBufSize - 1] := Beams [i].direction
  end;

begin

  InitField;
  Tick := 0;
  repeat
    WaitTime;
    Inc (Tick);
    VideoStop;
    ReadMvBuf;
{    if (Tick = speed) and (AliveBeams > 1) then}
    if (Tick = speed) and (AliveBeams > 0) then
    begin
      Inc (NoOfMoves);
{      PrintTopLine(NoOfMoves);}
      Tick:=0;
      for i := 0 to NoOfPlayers - 1 do
	with Beams [i] do
	  if alive then
	  begin
	    NewDir := direction;
	    ProcessMvBuf (i, NewDir);
	    DrawBeamBody (i, headX, headY, direction, NewDir);
	    direction := NewDir;
	    case NewDir of
	      North : headY := (headY + FieldHeight - 1) mod FieldHeight;
	      East  : headX := (headX + 1) mod FieldWidth;
	      South : headY := (headY + 1) mod FieldHeight;
	      West  : headX := (headX + FieldWidth - 1) mod FieldWidth;
	    end;
	    if Board [headX, headY] then alive := False
	      else Board [headX, headY] := True;
	    if not alive then
	    begin
	      DrawBeamHead (4, headX, headY, NewDir);
	      DieMusic;
	      Dec (AliveBeams)
	    end;
	    DrawBeamHead (i, headX, headY, NewDir);
	  end;
      MoveMusic;
    end;
    for i := 0 to NoOfPlayers - 1 do
      if not Beams [i].alive then
	Fade (i, FinishedBeams);
    VideoShow;
  until endgame or (FinishedBeams >= NoOfPlayers);
  {until endgame or (FinishedBeams >= NoOfPlayers - 1);}
  Session := 0;
  if AliveBeams = 1 then
  begin
    i := 0;
    while not (Beams [i].alive) do Inc(i);
    Session := i;
  end;
end;

begin
  ClrScr;
  winner := Session (1,1,False,endgame);
end.
